(*^
::[	Information =

	"This is a Mathematica Notebook file.  It contains ASCII text, and can be
	transferred by email, ftp, or other text-file transfer utility.  It should
	be read or edited using a copy of Mathematica or MathReader.  If you 
	received this as email, use your mail application or copy/paste to save 
	everything from the line containing (*^ down to the line containing ^*)
	into a plain text file.  On some systems you may have to give the file a 
	name ending with ".ma" to allow Mathematica to recognize it as a Notebook.
	The line below identifies what version of Mathematica created this file,
	but it can be opened using any other version as well.";

	FrontEndVersion = "Macintosh Mathematica Notebook Front End Version 2.2";

	MacintoshStandardFontEncoding; 
	
	fontset = title, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, bold, e8,  24, "Times"; 
	fontset = subtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, M7, bold, e6,  20, "Times"; 
	fontset = subsubtitle, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeTitle, center, M7, italic, e6,  14, "Times"; 
	fontset = section, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, grayBox, M22, bold, a20,  18, "Times"; 
	fontset = subsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, blackBox, M19, bold, a15,  14, "Times"; 
	fontset = subsubsection, inactive, noPageBreakBelow, nohscroll, preserveAspect, groupLikeSection, whiteBox, M18, bold, a12,  12, "Times"; 
	fontset = text, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Helvetica"; 
	fontset = smalltext, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = input, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeInput, M42, N23, bold, L-5,  12, "Courier"; 
	fontset = output, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = message, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, R65535, L-5,  12, "Courier"; 
	fontset = print, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, L-5,  12, "Courier"; 
	fontset = info, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeOutput, M42, N23, B65535, L-5,  12, "Courier"; 
	fontset = postscript, PostScript, formatAsPostScript, output, inactive, noPageBreakInGroup, nowordwrap, preserveAspect, groupLikeGraphics, M7, l34, w282, h287,  12, "Courier"; 
	fontset = name, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7, italic,  10, "Geneva"; 
	fontset = header, inactive, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = leftheader, inactive, L2,  12, "Times"; 
	fontset = footer, inactive, noKeepOnOnePage, preserveAspect, center, M7,  12, "Times"; 
	fontset = leftfooter, inactive, L2,  12, "Times"; 
	fontset = help, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  10, "Times"; 
	fontset = clipboard, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = completions, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special1, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special2, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special3, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special4, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	fontset = special5, inactive, nohscroll, noKeepOnOnePage, preserveAspect, M7,  12, "Times"; 
	paletteColors = 128; showRuler; automaticGrouping; currentKernel; 
]
:[font = title; inactive; preserveAspect; startGroup]
Analyse ebener Mehrkoerpersysteme 
:[font = subsubtitle; inactive; preserveAspect]
COPYRIGHT Prof. Dr. Oskar Wallrapp, Fachhochschule Muenchen. April 1999
:[font = subtitle; inactive; preserveAspect; backColorGreen = 65534; backColorBlue = 51118; startGroup]
Probemstellung, Fortsetzung der Loesung, Teil 4
:[font = text; inactive; preserveAspect; backColorGreen = 65534; backColorBlue = 51118]
Hier werden die Matrizen des DAE-Systems nach Einbringung der Zahlenwerte ausgedruckt. 
Die Abschnitte 1, 2 und 3 aller elatischen Koerper muessen bereits durchgerechnet sein!
Die Matrizen erhalten alle den Index 2.

Hinweise zur Loesung:
Es wird vorausgesetzt, dass der Anwender die Grundlagen von Mathematica  beherrscht.
Alle Parameter werden in  Abschnitt Festlegung der Parameter  definiert. Fuer eigene Modell sind nur hier Aenderungen vorzunehmen. 
Zur Loesung der Aufgaben sind die anschlieenden Abschnitte durchzurechnen. Dabei sind die Hinweise von Mathematica  zu beachten.
Insbesondere kann es bei anderen Parametern zu Konvergenzproblemen oder Skalierungsproblemen der Grafiken fuehren.
;[s]
9:0,0;217,1;238,0;299,2;311,0;360,2;384,0;560,2;571,0;701,-1;
3:5,14,10,Helvetica,0,12,0,0,0;1,14,10,Helvetica,1,12,0,0,0;3,14,10,Helvetica,2,12,0,0,0;
:[font = input; preserveAspect; backColorBlue = 51117]
MKSName
:[font = input; preserveAspect; backColorGreen = 65534; backColorBlue = 51118; endGroup]

:[font = subtitle; inactive; Cclosed; preserveAspect; startGroup]
Loesung:
4. Matrizen des DAE-Systems
;[s]
2:0,0;9,1;37,-1;
2:1,21,15,Times,1,20,0,0,0;1,19,14,Times,1,18,0,0,0;
:[font = subsection; inactive; preserveAspect; startGroup]
4.1 Abfragen von System-Variablen
:[font = input; preserveAspect; startGroup]
nz
nc
:[font = output; output; inactive; preserveAspect]
6
;[o]
6
:[font = output; output; inactive; preserveAspect; endGroup]
6
;[o]
6
:[font = input; preserveAspect; startGroup]
zI
zII
:[font = output; output; inactive; preserveAspect]
{rhox[1], rhoy[1], al[1], rhox[2], rhoy[2], al[2]}
;[o]
{rhox[1], rhoy[1], al[1], rhox[2], rhoy[2], al[2]}
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{vx[1], vy[1], oz[1], vx[2], vy[2], oz[2]}
;[o]
{vx[1], vy[1], oz[1], vx[2], vy[2], oz[2]}
:[font = subsection; inactive; preserveAspect; startGroup]
4.2 Matrizen der Knoten-Koordinatensysteme
:[font = input; preserveAspect; startGroup]
Do [Print["k=",k];
    Print["  Ttki:   ",Ttki[[k]]/.Masssub/.Pi->N[Pi,6]];
    Print["  Trki:   ",Trki[[k]]/.Masssub/.Pi->N[Pi,6]];
    Print["  rhoki:  ",rhoki[[k]]/.Masssub/.Pi->N[Pi,6]];
    Print["  Dki:    ",Dki[[k]]/.Masssub/.Pi->N[Pi,6]];
    Print["  zetatki:",zetatki[[k]]/.Masssub/.Pi->N[Pi,6]];
    Print["  zetarki:",zetarki[[k]]/.Masssub/.Pi->N[Pi,6]];
,{k,nK}]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
k=1
  Ttki:   {{1, 0, 0}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[1], rhoy[1], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[1] vy[1]), oz[1] vx[1], 0}
  zetarki:{0, 0, 0}
k=2
  Ttki:   {{1, 0, 0.3044}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[1], -0.3044 + rhoy[1], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[1] vy[1]), oz[1] (0.3044 oz[1] + vx[1]), 0}
  zetarki:{0, 0, 0}
k=3
  Ttki:   {{1, 0, -0.14}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[1], 0.14 + rhoy[1], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[1] vy[1]), oz[1] (-0.14 oz[1] + vx[1]), 0}
  zetarki:{0, 0, 0}
k=4
  Ttki:   {{1, 0, 0}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[2], rhoy[2], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[2] vy[2]), oz[2] vx[2], 0}
  zetarki:{0, 0, 0}
k=5
  Ttki:   {{1, 0, -3.073}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[2], 3.073 + rhoy[2], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[2] vy[2]), oz[2] (-3.073 oz[2] + vx[2]), 0}
  zetarki:{0, 0, 0}
k=6
  Ttki:   {{1, 0, -6.8}, {0, 1, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 1}}
  rhoki:  {rhox[2], 6.8 + rhoy[2], 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{-(oz[2] vy[2]), oz[2] (-6.8 oz[2] + vx[2]), 0}
  zetarki:{0, 0, 0}
k=7
  Ttki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}}
  rhoki:  {0, 0, 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{0, 0, 0}
  zetarki:{0, 0, 0}
k=8
  Ttki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}}
  Trki:   {{0, 0, 0}, {0, 0, 0}, {0, 0, 0}}
  rhoki:  {0, 7, 0}
  Dki:    {{1, 0, 0}, {0, 1, 0}, {0, 0, 1}}
  zetatki:{0, 0, 0}
  zetarki:{0, 0, 0}
:[font = subsection; inactive; preserveAspect; startGroup]
4.3 System-Massenmatrix M(nz,nz):           Achtung: Matrix Me muss eine Einheitsmatrix sein!
:[font = input; preserveAspect; startGroup]
nqi
:[font = output; output; inactive; preserveAspect; endGroup]
nqi
;[o]
nqi
:[font = input; preserveAspect; startGroup]
nn = 0; M2 = Expand[MMat/.Masssub];
Do [  nqi = Mass[[i,13]];
	  nsi = nzi[[i]]-nqi;
	  Print["i=",i," nsi=",nsi];
	  nne = nz - indexzi[[i,2]];
	  nnee= nz - indexzi[[i,1]] - nsi;
      If[Mass[[i,2]]===e3D||Mass[[i,2]]===e2D,
          Do [ M2[[nn+j1]] = Join[Flatten[M2[[nn+j1]]],Table[0,{nne}]];     (*elastisch*)
             (*   Print[nn+j1," ",nsi,nne," ",M2[[nn+j1]]]; *)
             ,{j1,nsi}];
          M2[[nn+nsi+1]] = Join[M2[[nn+nsi+1]],Table[0,{nnee}]];
          Do [ Do [M2[[nn+nsi+j2,nn+j1]] = M2[[nn+j1,nn+nsi+j2]];,{j1,nsi}];
            (*  Print[nn+nsi+j2," ",nsi,nne," ",M2[[nn+nsi+j2]]]; *)
            ,{j2,nqi}];, 
 
          Do [ M2[[nn+j1]] = Join[Flatten[M2[[nn+j1]]],Table[0,{nne}]];     (* oder starr *)
             Print[nn+j1," ",nsi,nne," ",M2[[nn+j1]]];
             ,{j1,nsi}];
        ];
      nn = nn + nzi[[i]];
,{i,n}]; 
:[font = print; inactive; preserveAspect; endGroup]
i=1 nsi=3
1 33 {14.205, 0, 4.324, 0, 0, 0}
2 33 {0, 14.205, 0, 0, 0, 0}
3 33 {4.324, 0, 9.454, 0, 0, 0}
i=2 nsi=3
4 30 {0, 0, 0, 58.212, 0, -178.885}
5 30 {0, 0, 0, 0, 58.212, 0}
6 30 {0, 0, 0, -178.885, 0, 1188.105}
:[font = input; preserveAspect; startGroup]
If[keyPrint==1,TableForm[M2]]
:[font = output; output; inactive; preserveAspect; fontLeading = 0; endGroup; endGroup]
TableForm[{{14.205, 0, 4.324002000000001, 0, 0, 0}, {0, 14.205, 0, 0, 0, 0}, {4.324002000000001, 0, 9.454, 0, 0, 0}, 
 
   {0, 0, 0, 58.21200000000001, 0, -178.885476}, {0, 0, 0, 0, 58.21200000000001, 0}, {0, 0, 0, -178.885476, 0, 1188.105}}]
;[o]
14.205   0        4.324   0          0        0

0        14.205   0       0          0        0

4.324    0        9.454   0          0        0

0        0        0       58.212     0        -178.885

0        0        0       0          58.212   0

0        0        0       -178.885   0        1188.105
:[font = subsection; inactive; preserveAspect; startGroup]
4.4 Verallgem. innere Kraefte he(nz) und Beitrag heK0ki(nz) geometrischer Steifigkeiten durch Knotenkraefte 
:[font = text; inactive; preserveAspect]
Beachte: K0t1 und K0omega3 sind bereits in Ct und Oe enthalten, sofern der Key  keyKgeo im File 1 auf 1 gesetzt wurde. Somit sind in M, homega und hg alle Beitraege infolge geometrischer Steifigkeiten enthalten.
;[s]
5:0,2;7,0;80,3;87,1;88,0;212,-1;
4:2,14,10,Helvetica,0,12,0,0,0;1,13,10,Courier,2,12,0,0,0;1,14,10,Helvetica,1,12,0,0,0;1,13,10,Courier,1,12,0,0,0;
:[font = subsubsection; inactive; preserveAspect; startGroup]
4.4.1 Koerperbezogene Matrizen infolge Ke und De
:[font = input; preserveAspect]
heK2        = Table[0,{n}];
heD2        = Table[0,{n}];
Do [ 
     If[Mass[[i,2]]===e3D||Mass[[i,2]]===e2D,
         nqi = Mass[[i,13]];       (* elastisch *)
         qi  = zI [[Range[indexzi[[i,2]]-nqi+1,indexzi[[i,2]]]]]; 
         qdi = zII[[Range[indexzi[[i,2]]-nqi+1,indexzi[[i,2]]]]];
         hh1 =       -Ke[i].qi;
         hh2 =       -De[i].qdi;

         hh1s = Join[Table[0,{nzsi[[i]]-1}],hh1];
         hh2s = Join[Table[0,{nzsi[[i]]-1}],hh2];
             ,                                               (* oder starr *)
         hh1s = Table[0,{nzi[[i]]}];                        
         hh2s = Table[0,{nzi[[i]]}]; 
    ];
           heK2[[i]] = Chop[hh1s];
           heD2[[i]] = Chop[hh2s];
  ,{i,n}]; 
:[font = input; preserveAspect; startGroup]
heK2 = Flatten[heK2]
:[font = output; output; inactive; preserveAspect; endGroup]
{0, 0, 0, 0, 0, 0}
;[o]
{0, 0, 0, 0, 0, 0}
:[font = input; preserveAspect; startGroup]
heD2 = Flatten[heD2]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{0, 0, 0, 0, 0, 0}
;[o]
{0, 0, 0, 0, 0, 0}
:[font = subsubsection; inactive; preserveAspect; startGroup]
4.4.2 Knotenbezogene Matrizen  infolge K0F1k und Fkix1[k], wo Fkix1[k] die Laengskraft im Balken am Knoten k ist.
:[font = input; preserveAspect; startGroup]
Clear[Fkix]
heK0ki = Table[0,{nK},{nz}];
Do [ i = KnotenKoerper[[k]];
     If[Mass[[i,2]]===e3D||Mass[[i,2]]===e2D,
         nqi = Mass[[i,13]];                        (* elastisch *)
         qi  = zI [[Range[indexzi[[i,2]]-nqi+1,indexzi[[i,2]]]]]; 
         hh1 =       -K0F1ki[k].qi * Fkix[k];     
         hh1s = Join[Table[0,{nzsi[[i]]-1}],hh1];
    ,                                               (* oder starr *)
         hh1s = Table[0,{nzi[[i]]}];                        
    ];
    Do[heK0ki[[k,indexzi[[i,1]]-1+j1]] = Chop[hh1s[[j1]]];,{j1,nzi[[i]]}];
    Print["k = ",k,": heK0ki(",nz,")=",heK0ki[[k]]];
,{k,nK}]; 
:[font = print; inactive; preserveAspect; endGroup; endGroup]
k = 1: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 2: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 3: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 4: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 5: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 6: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 7: heK0ki(6)={0, 0, 0, 0, 0, 0}
k = 8: heK0ki(6)={0, 0, 0, 0, 0, 0}
:[font = subsubsection; inactive; preserveAspect; startGroup]
Gesamtsumme: he2 = heK2 + heK0ki
:[font = input; preserveAspect; startGroup]
If[keyKgeo===1,he2 = heK2+Sum[heK0ki[[k]],{k,nK}],he2 = heK2]; 
TableForm[he2]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup; endGroup]
TableForm[{0, 0, 0, 0, 0, 0}]
;[o]
0

0

0

0

0

0
:[font = subsection; inactive; preserveAspect; startGroup]
4.5 Verallgemeinerte Zentrifugalkraefte homeaga(nz)
:[font = input; preserveAspect; startGroup]
homega2 = Flatten[homega]/.Masssub; homega2//MatrixForm
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
MatrixForm[{14.205*oz[1]*vy[1], -4.324002000000001*oz[1]^2 - 14.205*oz[1]*vx[1], 4.324002000000001*oz[1]*vy[1], 
 
   58.21200000000001*oz[2]*vy[2], 178.885476*oz[2]^2 - 58.21200000000001*oz[2]*vx[2], -178.885476*oz[2]*vy[2]}]
;[o]

14.205 oz[1] vy[1]

            2
-4.324 oz[1]  - 14.205 oz[1] vx[1]


4.324 oz[1] vy[1]


58.212 oz[2] vy[2]

             2
178.885 oz[2]  - 58.212 oz[2] vx[2]


-178.885 oz[2] vy[2]
:[font = subsection; inactive; preserveAspect; startGroup]
4.6 Verallgemeinerte Gewichtskraefte hg(nz)
:[font = input; preserveAspect; startGroup]
gIi//TableForm
:[font = output; output; inactive; preserveAspect; endGroup]
TableForm[{{gErd*Cos[al[1]], -(gErd*Sin[al[1]]), 0}, {gErd*Cos[al[2]], -(gErd*Sin[al[2]]), 0}, {0, 0, 0}}]
;[o]
gErd Cos[al[1]]   -(gErd Sin[al[1]])   0

gErd Cos[al[2]]   -(gErd Sin[al[2]])   0

0                 0                    0
:[font = input; preserveAspect; startGroup]
hg2 = Expand[Flatten[hg]/.Masssub];
gFeldx = Array[gx,n];
gFeldy = Array[gy,n];
gFeldz = Array[gz,n];
Do [ gx[i] = gIi[[i,1]]/.Masssub;
     gy[i] = gIi[[i,2]]/.Masssub; 
     gz[i] = gIi[[i,3]]/.Masssub;
,{i,n}];    hg2//TableForm
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
TableForm[{0, 0, 0, 0, 0, 0}]
;[o]
0

0

0

0

0

0
:[font = subsection; inactive; preserveAspect; startGroup]
4.7 Matrix Tr und verallgemeinerte Kraefte der Kraftelemente hf(nz)
:[font = input; preserveAspect; startGroup]
Tr2 = Expand[Tr/.Masssub]; 
hf2 = Expand[hf/.Masssub]; 
Do [Print["r=",r];
    Print["  Tr2(6,",nz,"): ",Tr2[[r]]];
    Print["  hf2(",nz,  "): ",hf2[[r]]];
,{r,nKe}]
:[font = print; inactive; preserveAspect; endGroup]
r=1
  Tr2(6,6): {{0, 0, 0, 1, 0, -7 Cos[al[2]] + rhoy[2]}, {0, 0, 0, 0, 1, -rhox[2] + 7 Sin[al[2]]}, {0, 0, 0, 0, 0, 0}, 
 
   {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 1}}
  hf2(6): {0, 0, 0, 0, -Fr[1], Fr[1] rhox[2] - 7 Fr[1] Sin[al[2]]}
:[font = subsubsection; inactive; preserveAspect; startGroup]
 Test von Tr mit Gr =  D[dr] . Z, Tr == Gr
:[font = input; preserveAspect; startGroup]
dr2 = dr/.Masssub
:[font = output; output; inactive; preserveAspect; endGroup]
{{rhox[2] - 7*Sin[al[2]], 6.8 - 7*Cos[al[2]] + rhoy[2], 0}}
;[o]
{{rhox[2] - 7 Sin[al[2]], 6.8 - 7 Cos[al[2]] + rhoy[2], 0}}
:[font = input; preserveAspect; startGroup]
betar2 = betar/.Masssub
:[font = output; output; inactive; preserveAspect; endGroup]
{al[2]}
;[o]
{al[2]}
:[font = input; preserveAspect; startGroup]
mat  = Table[0,{3},{nz}];
Do [ Do [ mat[[c,z]] = D[dr2[[1,c]],zI[[z]]];,{z,nz}];
  ,{c,3}];   
Gr2 = Simplify[mat.Z]; 
Do [Print["c=",c,"  ",Gr2[[c]]],{c,3}]
:[font = print; inactive; preserveAspect; endGroup]
c=1  {0, 0, 0, 1, 0, -7 Cos[al[2]] + rhoy[2]}
c=2  {0, 0, 0, 0, 1, -rhox[2] + 7 Sin[al[2]]}
c=3  {0, 0, 0, 0, 0, 0}
:[font = input; preserveAspect; startGroup]
Expand[Gr2[[1]] - Tr[[1,1]]/.Masssub]
:[font = output; output; inactive; preserveAspect; endGroup]
{0, 0, 0, 0, 0, 0}
;[o]
{0, 0, 0, 0, 0, 0}
:[font = input; preserveAspect; startGroup]
Expand[Gr2[[2]] - Tr[[1,2]]/.Masssub]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup; endGroup]
{0, 0, 0, 0, 0, 0}
;[o]
{0, 0, 0, 0, 0, 0}
:[font = subsection; inactive; preserveAspect; startGroup]
4.8 Matrizen Ts und xis 
:[font = input; preserveAspect; startGroup]
Ts2 = Simplify[Expand[Ts /.Masssub]];
xis2= xis/.Masssub;
Do [Print["s=",s];
    Print["  Ts(6,",nz,")= ",Ts2 [[s]]];
    Print["  xis(",nz,")= " ,xis2[[s]]];
,{s,nG}]
:[font = print; inactive; preserveAspect; endGroup; endGroup]
s=1
  Ts(6,6)= {{1, 0, rhoy[1], 0, 0, 0}, {0, 1, -rhox[1], 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, 
 
   {0, 0, 1, 0, 0, 0}}
  xis(6)= {oz[1] vy[1] - oz[1] (oz[1] rhox[1] + 2 (-(oz[1] rhox[1]) + vy[1])), 
 
   -(oz[1] vx[1]) + oz[1] (-(oz[1] rhoy[1]) + 2 (oz[1] rhoy[1] + vx[1])), 0, 0, 0, 0}
s=2
  Ts(6,6)= {{-Cos[al[1] - al[2]], Sin[al[1] - al[2]], 0.14 Cos[al[1] - al[2]], 1, 0, 
 
    -0.14 Cos[al[1] - al[2]] - Cos[al[1] - al[2]] rhoy[1] + rhoy[2] - rhox[1] Sin[al[1] - al[2]]}, 
 
   {-Sin[al[1] - al[2]], -Cos[al[1] - al[2]], 0.14 Sin[al[1] - al[2]], 0, 1, 
 
    Cos[al[1] - al[2]] rhox[1] - rhox[2] - 0.14 Sin[al[1] - al[2]] - rhoy[1] Sin[al[1] - al[2]]}, {0, 0, 0, 0, 0, 0}, 
 
   {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, -1, 0, 0, 1}}
  xis(6)= {-(oz[1] Sin[al[1] - al[2]] (-0.14 oz[1] + vx[1])) - Cos[al[1] - al[2]] oz[1] vy[1] + oz[2] vy[2] - 
 
    oz[2] (oz[2] (-(Cos[al[1] - al[2]] rhox[1]) + rhox[2] + (0.14 + rhoy[1]) Sin[al[1] - al[2]]) + 
 
       2 (0.14 oz[1] Sin[al[1] - al[2]] + oz[2] (Cos[al[1] - al[2]] rhox[1] - rhox[2] - (0.14 + rhoy[1]) Sin[al[1] - al[2]]) - 
 
          Sin[al[1] - al[2]] vx[1] - Cos[al[1] - al[2]] vy[1] + vy[2])), 
 
   Cos[al[1] - al[2]] oz[1] (-0.14 oz[1] + vx[1]) - oz[2] vx[2] - oz[1] Sin[al[1] - al[2]] vy[1] + 
 
    oz[2] (-(oz[2] (-(Cos[al[1] - al[2]] (0.14 + rhoy[1])) + rhoy[2] - rhox[1] Sin[al[1] - al[2]])) + 
 
       2 (0.14 Cos[al[1] - al[2]] oz[1] + oz[2] (-(Cos[al[1] - al[2]] (0.14 + rhoy[1])) + rhoy[2] - 
 
             rhox[1] Sin[al[1] - al[2]]) - Cos[al[1] - al[2]] vx[1] + vx[2] + Sin[al[1] - al[2]] vy[1])), 0, 0, 0, 0}
s=3
  Ts(6,6)= {{0, 0, 0, -Cos[al[2]], Sin[al[2]], 6.8 Cos[al[2]]}, {0, 0, 0, -Sin[al[2]], -Cos[al[2]], 6.8 Sin[al[2]]}, 
 
   {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, -1}}
  xis(6)= {-(oz[2] Sin[al[2]] (-6.8 oz[2] + vx[2])) - Cos[al[2]] oz[2] vy[2], 
 
   Cos[al[2]] oz[2] (-6.8 oz[2] + vx[2]) - oz[2] Sin[al[2]] vy[2], 0, 0, 0, 0}
:[font = subsection; inactive; preserveAspect; startGroup]
4.9 Matrizen der impliziten Zwangsbedingungen gs(nc) und Gs(nc,nz)
:[font = input; preserveAspect; startGroup]
gs2 = gs/.Masssub; gs2//TableForm
:[font = output; output; inactive; preserveAspect; endGroup]
TableForm[{rhox[1], rhoy[1], -100*Pi*t + al[1], -(Cos[al[1] - al[2]]*rhox[1]) + rhox[2] + (0.14 + rhoy[1])*Sin[al[1] - al[2]], 
 
   -(Cos[al[1] - al[2]]*(0.14 + rhoy[1])) + rhoy[2] - rhox[1]*Sin[al[1] - al[2]], 
 
   -(Cos[al[2]]*rhox[2]) + (6.8 + rhoy[2])*Sin[al[2]]}]
;[o]
rhox[1]

rhoy[1]

-100 Pi t + al[1]

-(Cos[al[1] - al[2]] rhox[1]) + rhox[2] + (0.14 + rhoy[1]) Sin[al[1] - al[2]]

-(Cos[al[1] - al[2]] (0.14 + rhoy[1])) + rhoy[2] - rhox[1] Sin[al[1] - al[2]]

-(Cos[al[2]] rhox[2]) + (6.8 + rhoy[2]) Sin[al[2]]
:[font = subsubsection; inactive; preserveAspect; startGroup]
Berechnung von Gs aus der Ableitung von gs: G_T = dgc / dzI . Z
:[font = input; preserveAspect; startGroup]
mat   = Table[0,{nc},{nz}];
Do [
   Do [
        mat[[c,z]] = D[gs2[[c]],zI[[z]]];,
   {z,nz}];,
{c,nc}];   
Gs2 = Simplify[mat.Z]; 
Do [Print["c=",c,": Gs2(",nz,")= ",Gs2[[c]]],{c,nc}]
:[font = print; inactive; preserveAspect; endGroup]
c=1: Gs2(6)= {1, 0, rhoy[1], 0, 0, 0}
c=2: Gs2(6)= {0, 1, -rhox[1], 0, 0, 0}
c=3: Gs2(6)= {0, 0, 1, 0, 0, 0}
c=4: Gs2(6)= {-Cos[al[1] - al[2]], Sin[al[1] - al[2]], 0.14 Cos[al[1] - al[2]], 1, 0, 
 
   -(Cos[al[1] - al[2]] (0.14 + rhoy[1])) + rhoy[2] - rhox[1] Sin[al[1] - al[2]]}
c=5: Gs2(6)= {-Sin[al[1] - al[2]], -Cos[al[1] - al[2]], 0.14 Sin[al[1] - al[2]], 0, 1, 
 
   Cos[al[1] - al[2]] rhox[1] - rhox[2] - (0.14 + rhoy[1]) Sin[al[1] - al[2]]}
c=6: Gs2(6)= {0, 0, 0, -Cos[al[2]], Sin[al[2]], 6.8 Cos[al[2]]}
:[font = text; inactive; preserveAspect]
Kontrolle muss Null ergeben
:[font = input; preserveAspect; startGroup]
Simplify[Gs - Gs2/.Masssub]
:[font = output; output; inactive; preserveAspect; endGroup]
{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}
;[o]
{{0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}, {0, 0, 0, 0, 0, 0}}
:[font = input; preserveAspect; startGroup]
kappas
:[font = output; output; inactive; preserveAspect; endGroup; endGroup; endGroup]
{0, 0, Omegar[1], 0, 0, 0}
;[o]
{0, 0, Omegar[1], 0, 0, 0}
:[font = subsection; inactive; preserveAspect; startGroup]
4.10 Bestimmung der Knotenkraefte von Gelenken und Kraftelementen: 
      Lambdaki = {fstki,fsrki} als Funktion von zI und my und den Funktionen der Kraftelemente
      Festlegung der Kraefte Fkix[k] von zI und my fuer heK0ki
:[font = subsubsection; inactive; preserveAspect; startGroup]
Definition der Zwangskraefte
:[font = input; preserveAspect; startGroup]
Clear[my]; mysMat = Array[my,nc]
:[font = output; output; inactive; preserveAspect; endGroup; endGroup]
{my[1], my[2], my[3], my[4], my[5], my[6]}
;[o]
{my[1], my[2], my[3], my[4], my[5], my[6]}
:[font = subsubsection; inactive; preserveAspect; startGroup]
Bestimmung der Kraefte an den Knoten infolge der Gelenke
:[font = input; preserveAspect; startGroup]
fstki      = Table[0,{nK},{3}];
fsrki      = Table[0,{nK},{3}];
ll = 0;
Do [
    kj = Gelenk[[s,2]];
    ki = Gelenk[[s,3]];
    i  = KnotenKoerper[[ki]];
    j  = KnotenKoerper[[kj]];
    ii = indexzi[[i,1]] - 1;
    jj = indexzi[[j,1]] - 1;
    DAA    = Simplify[Dki[[ki]].Ai[[i]].Transpose[Ai[[j]]]];
    mys    = mysDef2D[Gelenk[[s,1]],ll+1];
    phibarT  = phibarTGelenk[Gelenk[[s,1]],Gelenk[[s,Range[4,6]]]];
    Lambdas  = Transpose[phibarT].mys;

    fstki[[ki]] =  Transpose[Dki[[ki]]] . Lambdas[[Range[1,3]]]/.Masssub;
    fsrki[[ki]] =  Transpose[Dki[[ki]]] . Lambdas[[Range[4,6]]]/.Masssub;
    fstki[[kj]] = -Transpose[DAA]       . Lambdas[[Range[1,3]]]/.Masssub;
    fsrki[[kj]] = -Transpose[DAA]       . Lambdas[[Range[4,6]]]/.Masssub;
    
    Print["s=",s,": Typ=",Gelenk[[s,1]]," ",ki," ",i," ",kj," ",j];
    Print["  mys      = ",mys,"  "];
    Print["  Lambdas  = ",Lambdas,"  "];
    Print["  phibarT  = ",phibarT,"  "];
    Print["  fstki-",ki,"  = ",fstki[[ki]]];
    Print["  fsrki-",ki,"  = ",fsrki[[ki]]];
    Print["  fstkj-",kj,"  = ",fstki[[kj]]];
    Print["  fsrkj-",kj,"  = ",fsrki[[kj]]];
    If[Gelenk[[s,1]]===D, ll = ll + 2];
    If[Gelenk[[s,1]]===S, ll = ll + 2];
    If[Gelenk[[s,1]]===DS,ll = ll + 1];
    If[Gelenk[[s,1]]===F, ll = ll + 3];
,{s,nG}];
:[font = print; inactive; preserveAspect; endGroup; endGroup]
s=1: Typ=F 1 1 7 3
  mys      = {my[1], my[2], 0, 0, 0, my[3]}  
  Lambdas  = {my[1], my[2], 0, 0, 0, my[3]}  
  phibarT  = {{1, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 1, 0}, 
 
   {0, 0, 0, 0, 0, 1}}  
  fstki-1  = {my[1], my[2], 0}
  fsrki-1  = {0, 0, my[3]}
  fstkj-7  = {-(Cos[al[1]] my[1]) + my[2] Sin[al[1]], -(Cos[al[1]] my[2]) - my[1] Sin[al[1]], 0}
  fsrkj-7  = {0, 0, -my[3]}
s=2: Typ=D 4 2 3 1
  mys      = {my[4], my[5], 0, 0, 0}  
  Lambdas  = {my[4], my[5], 0, 0, 0, 0}  
  phibarT  = {{1, 0, 0, 0, 0, 0}, {0, 1, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 1, 0}}  
  fstki-4  = {my[4], my[5], 0}
  fsrki-4  = {0, 0, 0}
  fstkj-3  = {-(Cos[al[1] - al[2]] my[4]) - my[5] Sin[al[1] - al[2]], -(Cos[al[1] - al[2]] my[5]) + my[4] Sin[al[1] - al[2]], 
 
   0}
  fsrkj-3  = {0, 0, 0}
s=3: Typ=DS 8 3 6 2
  mys      = {my[6], 0, 0, 0}  
  Lambdas  = {my[6], 0, 0, 0, 0, 0}  
  phibarT  = {{1, 0, 0, 0, 0, 0}, {0, 0, 1, 0, 0, 0}, {0, 0, 0, 1, 0, 0}, {0, 0, 0, 0, 1, 0}}  
  fstki-8  = {my[6], 0, 0}
  fsrki-8  = {0, 0, 0}
  fstkj-6  = {-(Cos[al[2]] my[6]), my[6] Sin[al[2]], 0}
  fsrkj-6  = {0, 0, 0}
:[font = subsubsection; inactive; preserveAspect; startGroup]
Bestimmung der Kraefte an den Knoten infolge der Kraftelemente
:[font = input; preserveAspect; startGroup]
frtki      = Table[0,{nK},{3}];
frrki      = Table[0,{nK},{3}];
Do [
    kj = Kraftele[[s,2]];
    ki = Kraftele[[s,3]];
    i  = KnotenKoerper[[ki]];
    j  = KnotenKoerper[[kj]];
    ii = indexzi[[i,1]] - 1;
    jj = indexzi[[j,1]] - 1;
    DAA    = Simplify[Dki[[ki]].Ai[[i]].Transpose[Ai[[j]]]];

    frtki[[ki]] =  Transpose[Dki[[ki]]] . Lambdar[[s,Range[1,3]]]/.Masssub;
    frrki[[ki]] =  Transpose[Dki[[ki]]] . Lambdar[[s,Range[4,6]]]/.Masssub;
    frtki[[kj]] = -Transpose[DAA]       . Lambdar[[s,Range[1,3]]]/.Masssub;
    frrki[[kj]] = -Transpose[DAA]       . Lambdar[[s,Range[4,6]]]/.Masssub;
    
    Print["r=",s,": Typ=",Kraftele[[s,1]]," ",ki," ",i," ",kj," ",j];
    Print["  Lambdar  = ",Lambdar[[s]],"  "];
    Print["  frtki-",ki,"  = ",frtki[[ki]]];
    Print["  frrki-",ki,"  = ",frrki[[ki]]];
    Print["  frtkj-",kj,"  = ",frtki[[kj]]];
    Print["  frrkj-",kj,"  = ",frrki[[kj]]];
,{s,nKe}];
:[font = print; inactive; preserveAspect; endGroup; endGroup]
r=1: Typ=F1 6 2 8 3
  Lambdar  = {0, -Fr[1], 0, 0, 0, 0}  
  frtki-6  = {0, -Fr[1], 0}
  frrki-6  = {0, 0, 0}
  frtkj-8  = {-(Fr[1] Sin[al[2]]), Cos[al[2]] Fr[1], 0}
  frrkj-8  = {0, 0, 0}
:[font = subsubsection; inactive; preserveAspect; startGroup]
Bestimmung der Knotenkraefte Fkix[k] und Fkix[k] und der Knotenmomente Lkiz[k] in koerperfester Basis. 
Sie sind u.a. fuer die Beitraege geometrischer Steifigkeiten erforderlich
:[font = input; preserveAspect; startGroup]
Do[Fkix[k] = fstki[[k,1]]+frtki[[k,1]]; 
   Fkiy[k] = fstki[[k,2]]+frtki[[k,2]];
   Lkiz[k] = fsrki[[k,3]]+frrki[[k,3]];
    Print["  Fkix[",k,"]  = ",Fkix[k]];
    Print["  Fkiy[",k,"]  = ",Fkiy[k]];
    Print["  Lkiz[",k,"]  = ",Lkiz[k]];
 ,{k,nK}];
:[font = print; inactive; preserveAspect; endGroup; endGroup; endGroup; endGroup; endGroup]
  Fkix[1]  = my[1]
  Fkiy[1]  = my[2]
  Lkiz[1]  = my[3]
  Fkix[2]  = 0
  Fkiy[2]  = 0
  Lkiz[2]  = 0
  Fkix[3]  = -(Cos[al[1] - al[2]] my[4]) - my[5] Sin[al[1] - al[2]]
  Fkiy[3]  = -(Cos[al[1] - al[2]] my[5]) + my[4] Sin[al[1] - al[2]]
  Lkiz[3]  = 0
  Fkix[4]  = my[4]
  Fkiy[4]  = my[5]
  Lkiz[4]  = 0
  Fkix[5]  = 0
  Fkiy[5]  = 0
  Lkiz[5]  = 0
  Fkix[6]  = -(Cos[al[2]] my[6])
  Fkiy[6]  = -Fr[1] + my[6] Sin[al[2]]
  Lkiz[6]  = 0
  Fkix[7]  = -(Cos[al[1]] my[1]) + my[2] Sin[al[1]]
  Fkiy[7]  = -(Cos[al[1]] my[2]) - my[1] Sin[al[1]]
  Lkiz[7]  = -my[3]
  Fkix[8]  = my[6] - Fr[1] Sin[al[2]]
  Fkiy[8]  = Cos[al[2]] Fr[1]
  Lkiz[8]  = 0
^*)
